#include "prehtml.h"

FILE *sortie=NULL; /* stream dans lequel on crit */
int affiche=1; /* vrai si on doit afficher ce qu'on lit*/
int chut=0; /* vrai si on a cache un morceau */

void print(char *format, ...){ /* crit dans le fichier cible */
  va_list ap;
  va_start(ap,format);
  if (debug && affiche && (!chut)) vfprintf(stdout,format,ap);
  if (affiche && (!chut)){
    if (sortie) vfprintf(sortie,format,ap);
    else erreur("print(): sortie==NULL");
  }
}
void put(char c){ /* idem, mais imite putc() au lieu de fprintf */
  if (debug && affiche && (!chut)) putc(c,stdout);
  if (affiche && (!chut)){
    if (sortie) putc(c,sortie);
    else erreur("put(): sortie==NULL");
  }
}
int vraifaux(char *commande,char *condition){ /* utilis par IF et WHILE */
  int i;
  char ligne[LONGUEUR_LIGNE];
  snprintf(ligne,LONGUEUR_LIGNE,"if %s ; then echo VRAI; else echo FAUX; fi",condition);
  envoieshell(ligne);
  recoitshell(ligne);
  if (!strcmp(ligne,"VRAI")) i=1;
  else if (!strcmp(ligne,"FAUX")) i=0;
  else {
    erreur("La condition <%s %s> ne donne ni vrai ni faux, mais:\n"
	   "%s\n",commande,condition,ligne);
  }
  if (recoitshell(ligne)){
    erreur("La condition <%s %s> donne des lignes en trop aprs VRAI ou FAUX:\n"
	   "%s\n",commande,chaine);
  }
  return i;
}

void traitefonction(void){
  char ligne[LONGUEUR_LIGNE],ligne2[LONGUEUR_LIGNE],**liste;
  char *result;
  int i;
  infofor *cefor;
  infowhile *cewhile;
  infoinclude *ceinc;
  /************ FONCTIONS IMMDIATES ******************/
  /* <SHELL instruction  excuter par sh sans regarder la rponse> */
  if (!strcmp(fonction,"shell"))execshell(chaine); /* c'est simple */
  /* <ECHO argument  sortir comme la commande echo> */
  else if (!strcmp(fonction,"echo")){ /* moins simple, mais a va */
    snprintf(ligne,LONGUEUR_LIGNE,"echo %s",chaine);
    envoieshell(ligne);
    while(recoitshell(ligne)) {
      result=recodeHTML(ligne);
      print("%s",result);
      free(result);
    }
  }
  /* <ECHOnoESC>: comme <ECHO> mais ne remet pas les chappements HTML */
  else if (!strcmp(fonction,"echonoesc")){ /* moins simple, mais a va */
    snprintf(ligne,LONGUEUR_LIGNE,"echo %s",chaine);
    envoieshell(ligne);
    while(recoitshell(ligne))
      print("\n%s",ligne);
  }
  /* <INCLUDE un fichier tel que le donne la commande echo> */
  else if (!strcmp(fonction,"*****include")){
    snprintf(ligne,LONGUEUR_LIGNE,"echo %s",chaine);
    envoieshell(ligne);
    recoitshell(ligne);
    while(recoitshell(ligne2)); /* si jamais a a renvoy plusieurs lignes*/
    inclure_fichier(ligne);
  }
  /* <SHELLECHO commande shell>, comme shell mais affiche le rsultat */
  else if (!strcmp(fonction,"shellecho")){
    envoieshell(chaine);
    i=0;
    while(recoitshell(ligne)) {
      if (i) put('\n'); /* sauts de ligne si plus d'une ligne */
      i=1;
      result=recodeHTML(ligne);
      print("%s",result);
      free(result);
    }
  }
  /* <SHELLECHOnoESC>: comme <SHELLECHO> mais ne remet pas les chappements HTML */
  else if (!strcmp(fonction,"shellechonoesc")){
    envoieshell(chaine);
    i=0;
    while(recoitshell(ligne))
      if (i) put('\n'); /* sauts de ligne si plus d'une ligne */
      i=1;
      print("%s",ligne);
      free(result);
  }
  /* <CHUT> ..... </CHUT>  cache une partie (pratique avec Netscape) */
  else if (!strcmp(fonction,"chut")){
    chut++;
  }
  else if (!strcmp(fonction,"/chut")){
    if (chut) chut--;
    else warning("</chut> trouv alors qu'on n'est pas dans <CHUT>");
  }
  /************** FONCTIONS IMBRIQUES *****************/
  /* <IF condition de if_shell, sans ";"> ... [ <ELSE> ... ] <FI>  */
  else if (!strcmp(fonction,"if")){
    i=vraifaux("if",chaine);
    ouvre_imbrique();
    imbriqueactu->type=IF;
    imbriqueactu->info.pourif.estvrai=i;
    if (!i){ /* la condition est fausse */
      if (!attend("else")){ /* on a trouv <fi> avant de trouver <else> */
	referme_imbrique();
      }
      /* sinon, c'est qu'on a trouv <else>, donc on excute */
    }
    /* sinon, c'est que la condition est vraie, donc on excute */
  }
  else if (!strcmp(fonction,"else")){
    if (imbriqueactu->type != IF || !imbriqueactu->info.pourif.estvrai){
      /* on a <else> et on n'tait pas dans <if>, ou on est dj ds <else>*/
      erreur("<else> inattendu");
    }
    attend("fi"); /* si le <else> est correct, on le saute jusqu' <fi> */
    referme_imbrique();
  }
  else if (!strcmp(fonction,"fi")){
    if (imbriqueactu->type != IF ){
      /* on a <fi> et on n'tait pas dans <if> */
      erreur("<fi> inattendu");
    }
    referme_imbrique();
  }
  /* <FOR variable IN liste telle qu'avec echo> blabla <DONE> */
  else if (!strcmp(fonction,"for")){
    ouvre_imbrique();
    imbriqueactu->type=FOR;
    cefor=&(imbriqueactu->info.pourfor);
    cefor->fichier=quelfichier();
    cefor->pos=queloffset();
    cefor->ligne=quelleligne();
    cefor->numval=0;
    snprintf(ligne,LONGUEUR_LIGNE,"liste_shell %s",chaine);
    envoieshell(ligne);
    if (!recoitshell(ligne)){
      erreur("Pas d'argument dans <for>: <FOR %s>",chaine);
    }
    cefor->var=strdup(ligne);
    i=1;
    if (recoitshell(ligne)) if (!strcasecmp(ligne,"in")) i=0;
    if (i){
      erreur("Syntaxe: <FOR variable IN liste>: <FOR %s>",chaine);
    }
    i=0;/*nombre de valeurs rentres*/
    liste=monalloc(sizeof(char *));
    while(recoitshell(ligne)){
      liste[i++]=strdup(ligne);
      liste=realloc(liste,sizeof(char *)*(i+1));
      if (!liste) {erreur("liste for: pas assez de mmoire");
      }
    }
    liste[i]=NULL;
    imbriqueactu->info.pourfor.liste=liste;
    if(liste[0]){
      snprintf(ligne,LONGUEUR_LIGNE,"read %s\n%s",cefor->var,
	      liste[0]);
      execshell(ligne);
    }
    else{ /*for variable in <liste vide>: d'accord, on ne fait rien*/
      referme_imbrique();
      attend("done");
    }
  }
  /* <WHILE condition_vraie> .... <DONE> */
  else if (!strcmp(fonction,"while")){
    ouvre_imbrique();
    imbriqueactu->type=WHILE;
    cewhile=&(imbriqueactu->info.pourwhile);
    cewhile->fichier=quelfichier();
    cewhile->pos=queloffset();
    cewhile->ligne=quelleligne();
    cewhile->condition=strdup(chaine);
    if (!vraifaux("while",chaine)){ /* si c'est faux, je saute  <DONE> */
      attend("done");
      referme_imbrique();
    }
  }
    
  /* <DONE>, qui termine <FOR> ou bien <WHILE> */
  else if (!strcmp(fonction,"done")){
    if (imbriqueactu->type==FOR){
      cefor=&(imbriqueactu->info.pourfor);
      cefor->numval++;
      if (!cefor->liste[cefor->numval]){ /* on a fini la liste*/
	referme_imbrique();
      }else{ /* on passe  la valeur suivante, et on reboucle*/
	snprintf(ligne,LONGUEUR_LIGNE,"read %s\n%s",cefor->var,
		cefor->liste[cefor->numval]);
	execshell(ligne);
	revient(cefor->fichier,cefor->pos,cefor->ligne);
      }
    }
    else if (imbriqueactu->type==WHILE){
      cewhile=&(imbriqueactu->info.pourwhile);
      if (vraifaux("while",cewhile->condition)){/* vrai, je retourne au while */
	revient(cewhile->fichier,cewhile->pos,cewhile->ligne);
      }else{ /* faux, je sors de l'imbrication */
	referme_imbrique();
      }
    }
  }
  /* <INCLUDE liste de fichiers> (format de cat) */
  /* et <NOTINCLUDE liste de fichiers> (idem mais n'affiche pas le contenu) */
  else if ((!strcmp(fonction,"include")) || 
	   (!strcmp(fonction,"notinclude"))){
    ouvre_imbrique();
    imbriqueactu->type=INCLUDE;
    ceinc=&(imbriqueactu->info.pourinclude);
    ceinc->affiche=affiche;
    /* si on n'affichait pas, on n'affiche toujours pas, mais si on
     * affichait et qu'on trouve <notinclude>, on n'affiche plus */
    if (!strcmp(fonction,"notinclude")) affiche=0;
    snprintf(ligne,LONGUEUR_LIGNE,"liste_shell %s",chaine);
    envoieshell(ligne);
    i=0;/*nombre de valeurs rentres*/
    liste=monalloc(sizeof(char *));
    while(recoitshell(ligne)){
      liste[i++]=strdup(ligne);
      liste=realloc(liste,sizeof(char *)*(i+1));
      if (!liste) {
	erreur("liste [not]include: pas assez de mmoire");
      }
    }
    liste[i]=NULL;
    ceinc->liste=liste;
    ceinc->numfich=0;
    if(liste[0]) /* INCLUDE <fichier>... : on inclut le premier */
      inclure_fichier(liste[0]);
    else /* INCLUDE <liste vide>: d'accord, on ne fait rien*/
      referme_imbrique();
  }
  /* cas spciaux du couple <GENERATE un fichier>....</GENERATE>
   * au lieu de crer le fichier du dpart, cre une srie de fichiers,
   * avec ces instructions mises dans une boucle */
  /* <GENERATE fichier> */
  else if (!strcmp(fonction,"generate")){
    snprintf(ligne,LONGUEUR_LIGNE,"echo %s",chaine);
    envoieshell(ligne);
    recoitshell(ligne);
    genere(ligne);
    if (recoitshell(ligne)) erreur("Trop de lignes dans la sortie de "
				   "<GENERATE %s>",chaine);
  }
  /* </GENERATE> */
  else if (!strcmp(fonction,"/generate")){
    degenere();
  }
    
  /* <FONCTION LISTE MAIS PAS ENCORE GRE > */    
  /* normalement, il n'y en a pas */
  
  /* <BODY> et </BODY>, pour n'inclure que le corps des fichiers */
  else if (!strcmp(fonction,"body")){
    /* rien  faire, si on est dans le main, sinon c'est anormal*/
    if (fichier_courant->pere)
      warning("balise <BODY> trouve dans un fichier inclus: 2e exemplaire?");
  }
  else if (!strcmp(fonction,"/body")){
    /* si on est dans un fichier inclus, on sort du fichier */
    if (fichier_courant->pere)
      fseek(fichier_courant->fd,0,SEEK_END); /* le prochain car. sera EOF */
  }
  
  else erreur("Erreur interne: fonction <%s> (argument='%s') "
	      "liste mais pas gre\n",fonction,chaine);
}
